rollout gui "" width:300 height:450
(
	button btn5 "" pos:[17,125] width:150 height:30
	editText edt1 " " pos:[50,20] width:150 height:15
	editText edt2 "  " pos:[50,50] width:150 height:15
    spinner spn1 "ʳ " pos:[55, 95] width:150 height:15 range:[1,175,125] type:#integer
	
	on btn5 pressed do(
		newtext = text size:100 kerning:-6 leading:0 pos:[0,0,350] name:"Fobj" text: edt1.text
		addModifier $Fobj (extrude amount:3)
		$Fobj.rotation.x_rotation = 90
		
		newtext = text size:100 kerning:-6 leading:0 pos:[0,0,0] name:"Sobj" text: edt2.text
		addModifier $Sobj (extrude amount:3)
		$Sobj.rotation.x_rotation = 90
		max views redraw
		
		global cd
		global NumChunks=spn1.value

		global fragmentMesh_Destination
		struct pointprops (id, coord)
		struct simplexprops (verts, num)

		fn compareFN v1 v2 valArray: centerpoint: = (
		local v1i = valArray[v1].coord - centerpoint
		local v2i = valArray[v2].coord - centerpoint
		local d = (length v1i)-(length v2i)
		case of (
		(d < 0.): -1
		(d > 0.): 1
		default: 0
		)
		)

		with redraw off (
			
		cd=$Sobj

		a = pcloud name: "PCloud_chunks" emitter:cd formation:3 quantityMethod:1 total_number: NumChunks viewPercent:100 seed:(random 0 1000) isHidden:true	

		fragmentMesh_Destination=#()
		fragmentMesh_Destination[NumChunks]=0

		start = timeStamp(); clearListener() 

		obj=cd
		tempmesh=copy obj
					temp_trans = tempmesh.transform
					tempmesh.transform = (matrix3 [1,0,0] [0,1,0] [0,0,1] [0,0,0])
					addModifier tempmesh (XForm())
					tempmesh.XForm.gizmo.transform = temp_trans
					collapseStack tempmesh
					temp=tempmesh.mesh
		rotPlane = plane isHidden:true

		pointsarr = #()
		pointsarr[NumChunks]=0

		curver=0

		for i = 1 to NumChunks do pointsarr[i]=pointprops id: i coord: (particlePos a i) 
		for i in pointsarr do print i --  (  )

		pp=pointsarr.count
		simplexarr = #()
		simplexarr[pp] = 0

		max create mode

		for k=1 to pp do (
		cp=pointsarr[k].coord
		indexArray = #()
		indexArray[pp] = 0
		indexArray = for i = 1 to pointsarr.count collect pointsarr[i].id
		qsort indexArray compareFN valArray: pointsarr centerpoint: cp
		deleteItem indexArray 1
		simplexarr[k]=simplexprops verts: indexArray num: indexArray.count
		txt="Sorting: "+(k as string) + " of "+(pp as string)
		pushPrompt txt
		)

		print "-BUILDING--"

			for k=1 to simplexarr.count do if not keyboard.ESCpressed then (
					cp=pointsarr[k].coord
					thePart = editable_mesh pos: cp
					thePart.pivot=cp
					thePart.name=uniqueName "Chunks_Sobj"
					thePart.mesh = tempmesh.mesh
					addModifier thePart (XForm())
					thePart.XForm.gizmo.pos = tempmesh.pos - cp
					collapseStack thePart
					
					mSlice = sliceModifier slice_type:2
					
					radius=length (pointsarr[simplexarr[k].verts[simplexarr[k].num]].coord - cp)
					distanceplane=0.5*radius
					i=0
					do (
								i+=1
								cv=simplexarr[k].verts[i]
						if cv!=k then (
								theVec = pointsarr[cv].coord - cp
								
								rotPlane.dir = theVec
								addModifier thePart mSlice
								mSlice.slice_plane.rotation = rotPlane.rotation
								mSlice.slice_plane.pos = theVec / 2
								addModifier thePart (cap_holes())
								collapseStack thePart
						if i>16 then (
							distanceplane=0.5*(length theVec)
							mi=[thePart.min.x, thePart.min.y, thePart.min.z]
							ma=[thePart.max.x, thePart.max.y, thePart.max.z]
							d=0.6*(distance mi ma)
							if d<radius then radius=d
						)
							txt="BUILD: "+(k as string)+" "+(i as string)+" of "+(simplexarr[k].num as string)
						pushPrompt txt
						)
					)
					while radius>distanceplane and i<simplexarr[k].num
						simplexarr[k].num=0
			
			convertTo thePart (Editable_Mesh)
			fragmentMesh_Destination[k]=thePart
					
			)

		delete rotPlane
		delete tempmesh
		delete a
		end = timeStamp()

		)
		hide $chunks_sobj*
		gravity pos:[0,0,445] isSelected:on iconSize:24.6905 transform:(matrix3 [1,0,0] [0,-1,0] [0,0,-1] [0,0,445])

		PF_Source X_Coord:20 Y_Coord:0 isSelected:on Logo_Size:119.928 Emitter_Length:142.494 Emitter_Width:200.157 Emitter_Height:0.01 pos:[0,0,445]
		particleFlow.BeginEdit()
		op1 = Birth()
		op2 = Position_Icon()
		op3 = Speed()
		op4 = Rotation()
		op5 = ShapeLibrary()
		op6 = RenderParticles()
		op7 = DisplayParticles()
		op7.color = $.wireColor
		ev1 = Event()
		ev1.SetPViewLocation ($.X_Coord) ($.Y_Coord+100)
		particleFlow.EndEdit()
		ev1.AppendAction op1
		ev1.AppendAction op2
		ev1.AppendAction op3
		ev1.AppendAction op4
		ev1.AppendAction op5
		ev1.AppendAction op7
		$.AppendAction op6
		$.AppendInitialActionList ev1
		
		particleFlow.openParticleView()
$'Particle View 01'.Origin = [772,115,0]
$'Particle View 01'.width = 564
$'Particle View 01'.height = 604
$'Particle View 01'.Divider = [1,261,0]
particleFlow.BeginEdit()
$'Event 01'.removeAction 1
delete $'Birth 01'
op1 = Birth_Script Proceed_Script:"
on ChannelsUsed pCont do
(
pCont.useTime = true --enable the Time channel
pCont.useAge = true --enable the Age channel
pCont.usePosition = true --enable the Position channel
pCont.useSpeed = true --enable the Speed channel
pCont.useShape = true --enable the Shape channel
)


on Init pCont do (
global bs = $Fobj
global a = $PCloud_chunks
global fragmentMesh

struct pointprops (id, coord)
struct simplexprops (verts, num)

fn compareFN v1 v2 valArray: centerpoint: = (
local v1i = valArray[v1].coord - centerpoint
local v2i = valArray[v2].coord - centerpoint
local d = (length v1i)-(length v2i)
case of (
(d < 0.): -1
(d > 0.): 1
default: 0
)
)
	
with redraw off ( 
if (a == undefined) then ( 

a = pcloud name: \"PCloud_chunks\" emitter:bs formation:3 quantityMethod:1 total_number: NumChunks viewPercent:100 seed:(random 0 1000) isHidden:true	
fragmentMesh=#()
fragmentMesh[NumChunks]=0
start = timeStamp(); clearListener()

obj=bs
tempmesh=copy obj
			temp_trans = tempmesh.transform
			tempmesh.transform = (matrix3 [1,0,0] [0,1,0] [0,0,1] [0,0,0])
			addModifier tempmesh (XForm())
			tempmesh.XForm.gizmo.transform = temp_trans
			collapseStack tempmesh
			temp=tempmesh.mesh
rotPlane = plane isHidden:true

pointsarr = #()
pointsarr[NumChunks]=0

curver=0

for i = 1 to NumChunks do pointsarr[i]=pointprops id: i coord: (particlePos a i)
pp=pointsarr.count
simplexarr = #()
simplexarr[pp] = 0

max create mode
for k=1 to pp do (
cp=pointsarr[k].coord
indexArray = #()
indexArray[pp] = 0
indexArray = for i = 1 to pointsarr.count collect pointsarr[i].id
qsort indexArray compareFN valArray: pointsarr centerpoint: cp
deleteItem indexArray 1
simplexarr[k]=simplexprops verts: indexArray num: indexArray.count
txt=\"Sorting: \"+(k as string) + \" of \"+(pp as string)
pushPrompt txt
)

print \"-BUILDING--\"

for k=1 to simplexarr.count do if not keyboard.ESCpressed then (
			cp=pointsarr[k].coord
			thePart = editable_mesh pos: cp
			thePart.pivot=cp
			thePart.name=uniqueName \"EMesh_Chunks\"
			thePart.mesh = tempmesh.mesh
			addModifier thePart (XForm())
			thePart.XForm.gizmo.pos = tempmesh.pos - cp
			collapseStack thePart
			mSlice = sliceModifier slice_type:2
			radius=length (pointsarr[simplexarr[k].verts[simplexarr[k].num]].coord - cp)
			distanceplane=0.5*radius
			i=0
			do ( 
						i+=1
						cv=simplexarr[k].verts[i]
				if cv!=k then (
						theVec = pointsarr[cv].coord - cp
						
						rotPlane.dir = theVec
						addModifier thePart mSlice
						mSlice.slice_plane.rotation = rotPlane.rotation
						mSlice.slice_plane.pos = theVec / 2
						addModifier thePart (cap_holes())
						collapseStack thePart
				if i>16 then (
					distanceplane=0.5*(length theVec)
					mi=[thePart.min.x, thePart.min.y, thePart.min.z]
					ma=[thePart.max.x, thePart.max.y, thePart.max.z]
					d=0.6*(distance mi ma) 
					if d<radius then radius=d
				)
					txt=\"BUILD: \"+(k as string)+\" \"+(i as string)+\" of \"+(simplexarr[k].num as string)
				pushPrompt txt
				)
			)
			while radius>distanceplane and i<simplexarr[k].num
	simplexarr[k].num=0
	
	convertTo thePart (Editable_Mesh) 
	fragmentMesh[k]=thePart
			
	)
	--redrawViews()

delete rotPlane
delete tempmesh
end = timeStamp()

hide fragmentMesh
)

)--end redraw

)--end initpcont



on Proceed pCont do (
t1 = pCont.getTimeStart() as float
t2 = pCont.getTimeEnd() as float
if ((t1 <= 0) and (t2 >= 0)) then ( 

i = 0 -- Initialize a counter

if (pCont.NumParticles() <= 0) then ( 

print(\"should be making fragments\")
print(\"assigning particles\")


for j in fragmentMesh do ( 

update j
particlePos1 = j.pos

pCont.AddParticle() 

i += 1 -- Increase the counter 

pCont.particleIndex = i

-- Set particle time and age to 0 (newborn particle!)
pCont.particleTime = 0
pCont.particleAge = 0

pCont.particlePosition = particlePos1 
pCont.particleSpeed = [0,0,0] 

pCont.particleShape = j.mesh 
) -- end for

print(\"assigned particles \" + (pCont.NumParticles() as string))

)
)

)



on Release pCont do ()\"
"
$'Event 01'.insertAction op1 1
particleFlow.EndEdit()
particleFlow.BeginEdit()
$'Event 01'.removeAction 2
delete $'Position Icon 01'
op1 = Speed()
$'Event 01'.insertAction op1 2
particleFlow.EndEdit()
particleFlow.BeginEdit()
$'Event 01'.removeAction 3
delete $'Speed 01'
op1 = Rotation()
$'Event 01'.insertAction op1 3
particleFlow.EndEdit()
particleFlow.BeginEdit()
$'Event 01'.removeAction 4
delete $'Rotation 01'
op1 = Spin()
$'Event 01'.insertAction op1 4
particleFlow.EndEdit()
particleFlow.BeginEdit()
$'Event 01'.removeAction 5
delete $'Shape 01'
op1 = Force()
$'Event 01'.insertAction op1 5
particleFlow.EndEdit()
particleFlow.BeginEdit()
op1 = Age_Test()
$'Event 01'.insertAction op1 7
particleFlow.EndEdit()
$'Particle View 01'.selected = #($'Speed 02')
$'Speed 02'.speed = 0.5
$'Speed 02'.variation = 5
$'Speed 02'.Divergence = 5
$'Particle View 01'.selected = #()
$'Particle View 01'.selected = #($'Rotation 02')
$'Rotation 02'.direction = 2
$'Particle View 01'.selected = #()
$'Particle View 01'.selected = #($'Spin 01')
$'Spin 01'.SpinRate = 30
$'Spin 01'.variation = 45
$'Particle View 01'.selected = #()
$'Particle View 01'.selected = #($'Force 01')
$'Force 01'.Force_Space_Warps.count = 0
$'Force 01'.Force_Space_Warps = #($'Gravity01')
$'Force 01'.Influence = 90
$'Force 01'.Sync = 1
$'Particle View 01'.selected = #()
$'Particle View 01'.selected = #($'Display 01')
$'Display 01'.type = 6
$'Particle View 01'.selected = #()
$'Particle View 01'.selected = #($'Age Test 01')
$'Age Test 01'.Test_Value = 3200
$'Age Test 01'.variation = 3200
$'Age Test 01'.Random_Seed = 9790
$'Particle View 01'.selected = #()
$'Particle View 01'.selected = #($'Display 01')
$'Particle View 01'.selected = #()
$'Particle View 01'.selected = #($'Force 01')
$'Particle View 01'.selected = #()
$'Particle View 01'.selected = #($'Spin 01')
$'Spin 01'.Random_Seed = 9816
$'Particle View 01'.selected = #()
$'Particle View 01'.selected = #($'Rotation 02')
$'Rotation 02'.Random_Seed = 9829
$'Particle View 01'.selected = #()
$'Particle View 01'.selected = #($'Event 01')
$'Particle View 01'.selected = #()
$'Particle View 01'.selected = #($'Speed 02')
$'Speed 02'.Random_Seed = 9842

particleFlow.BeginEdit()
ev1 = Event()
ev1.setPViewLocation 23 297
op1 = Force()
ev1.appendAction op1
op2 = DisplayParticles()
op2.color = ev1.wireColor
ev1.appendAction op2
particleFlow.EndEdit()
particleFlow.BeginEdit()
op1 = Keep_Apart()
$'Event 02'.insertAction op1 2
particleFlow.EndEdit()
particleFlow.BeginEdit()
op1 = Speed()
$'Event 02'.insertAction op1 3
particleFlow.EndEdit()
particleFlow.BeginEdit()
op1 = Spin()
$'Event 02'.insertAction op1 4
particleFlow.EndEdit()
particleFlow.BeginEdit()
op1 = Find_Target()
$'Event 02'.insertAction op1 6
particleFlow.EndEdit()
$'Particle View 01'.selected = #()
$'Particle View 01'.selected = #($'Force 02')
$'Force 02'.Force_Space_Warps.count = 0
$'Force 02'.Force_Space_Warps = #($'Gravity01')
$'Force 02'.Influence = 120
$'Force 02'.Sync = 1
$'Particle View 01'.selected = #()
$'Particle View 01'.selected = #($'Keep Apart 01')
$'Keep Apart 01'.Force = 20
$'Keep Apart 01'.Accel_Limit = 300
$'Keep Apart 01'.Range_Type = 1
$'Keep Apart 01'.Core_Percentage = 110
$'Keep Apart 01'.Falloff_Percentage = 145
$'Keep Apart 01'.variation = 10
$'Keep Apart 01'.Scope_Type = 2
$'Keep Apart 01'.Selected_Events = #($'Event 01'.handle)
$'Keep Apart 01'.Selected_Events = #($'Event 01'.handle, $'Event 02'.handle)
$'Keep Apart 01'.Random_Seed = 10168
$'Particle View 01'.selected = #()
$'Particle View 01'.selected = #($'Speed 01')
$'Speed 01'.speed = 20
$'Speed 01'.variation = 30
$'Speed 01'.Divergence = 5
$'Speed 01'.Random_Seed = 10201
$'Particle View 01'.selected = #()
$'Particle View 01'.selected = #($'Spin 02')
$'Spin 02'.SpinRate = 75
$'Spin 02'.variation = 50
$'Spin 02'.Random_Seed = 10234
$'Particle View 01'.selected = #()
$'Particle View 01'.selected = #($'Display 02')
$'Display 02'.type = 6
$'Particle View 01'.selected = #()
$'Particle View 01'.selected = #($'Find Target 01')
$'Find Target 01'.Speed_Type = 1
$'Find Target 01'.Timing_Type = 0
$'Find Target 01'.time = 19200
$'Find Target 01'.Time_Variation = 1120
$'Find Target 01'.Target_Type = 1
$'Find Target 01'.Target_Objects.count = 0
$'Find Target 01'.Target_Objects = #($'Sobj')
$'Find Target 01'.Follow_Target = on
$'Age Test 01'.setNextActionList $'Event 02' $'Age Test 01'


particleFlow.BeginEdit()
ev1 = Event()
ev1.setPViewLocation 27 478
op1 = Spin()
ev1.appendAction op1
op2 = DisplayParticles()
op2.color = ev1.wireColor
ev1.appendAction op2
particleFlow.EndEdit()
particleFlow.BeginEdit()
op1 = Script_Operator Proceed_Script:"on ChannelsUsed pCont do
(
pCont.useVector = true
pCont.useTM = true
pCont.useShape = true
)


on Init pCont do
(
global gr = $Chunks_Sobj*
global NumChunks=gr.count
global fragments
fragments=#()
fragments[NumChunks]=0
for i=1 to gr.count do fragments[i]=gr[i]
)

on Proceed pCont do
( 
	count = pCont.NumParticles()
	for i in 1 to count do (
	pCont.particleIndex = i 
	vpos = fragments[i].pos 
	pCont.particleVector = vpos 
	pCont.particleShape = fragments[i].mesh 
	pCont.particleTM=fragments[i].transform 
	)
)

on Release pCont do ()
"
$'Event 03'.insertAction op1 3
particleFlow.EndEdit()
particleFlow.BeginEdit()
op1 = Find_Target()
$'Event 03'.insertAction op1 4
particleFlow.EndEdit()
$'Particle View 01'.selected = #()
$'Particle View 01'.selected = #($'Spin 03')
$'Spin 03'.SpinRate = 0
$'Particle View 01'.selected = #()
$'Particle View 01'.selected = #($'Script Operator 01')
$'Particle View 01'.selected = #()
$'Particle View 01'.selected = #($'Display 03')
$'Display 03'.type = 6
$'Particle View 01'.selected = #()
$'Particle View 01'.selected = #($'Script Operator 01')
$'Particle View 01'.selected = #()
$'Particle View 01'.selected = #($'Find Target 02')
$'Find Target 02'.Speed_Type = 1
$'Find Target 02'.Timing_Type = 0
$'Find Target 02'.time = 23200
$'Find Target 02'.Time_Variation = 0
$'Find Target 02'.Subframe_Sampling = off
$'Find Target 02'.Use_Docking_Speed = on
$'Find Target 02'.Subframe_Sampling = on
$'Find Target 02'.Docking_Speed = 5
$'Find Target 02'.Docking_Speed_Variation = 3
$'Find Target 02'.Aim_Point_Type = 2
$'Find Target 02'.Docking_Type = 2
$'Find Target 02'.Docking_Distance = 9.04292
$'Find Target 02'.Random_Seed = 11520
$'Find Target 01'.setNextActionList $'Event 03' $'Find Target 01'

		
		redrawViews()

		
	)
)
createDialog gui